using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        [DllImport("gdi32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        private static extern bool BitBlt(IntPtr hDC, int x, int y, int nWidth, int nHeight, IntPtr hSrcDC, int xSrc, int ySrc, int dwRop);

        public Form1()
        {
            InitializeComponent();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            this.radCarousel1.CarouselElement.CarouselItemContainer.SelectedIndex++;
        }

        
        private void Form1_Load(object sender, EventArgs e)        
        {
            this.radPanel1.Location = new Point(-1000, -1000);
            this.panel2.Location = new Point(-1000, -1000);

            this.radCarousel1.CarouselElement.CarouselItemContainer.MouseDown += new MouseEventHandler(CarouselItemContainer_MouseDown);

            StartLooping();
        }

        void CarouselItemContainer_MouseDown(object sender, MouseEventArgs e)
        {
            RefreshPanels();
            HideAllPanels();
        }        

        public void StartLooping()
        {
            this.radCarousel1.EasingType = RadEasingType.Linear;
            this.timer1.Start();
        }

        public void StopLooping()
        {
            this.radCarousel1.EasingType = RadEasingType.OutQuad;
            this.timer1.Stop();
        }

        private void radCarousel1_MouseEnter(object sender, EventArgs e)
        {
            this.StopLooping();
        }

        private void radCarousel1_MouseLeave(object sender, EventArgs e)
        {
            if (this.radPanel1.Visible || this.panel2.Visible)
                return;

            this.StartLooping();
        }

        private void CopyPanels()
        {
            Bitmap bmp1 = new Bitmap(this.radPanel1.Size.Width, this.radPanel1.Size.Height);
            Bitmap bmp2 = new Bitmap(this.panel2.Size.Width, this.panel2.Size.Height);

            this.radPanel1.DrawToBitmap(bmp1, new Rectangle(Point.Empty, this.radPanel1.Size));
            this.panel2.DrawToBitmap(bmp2, new Rectangle(Point.Empty, this.panel2.Size));            

            this.radButtonElement1.Image = bmp1.GetThumbnailImage(170, 100, AbortCallback, IntPtr.Zero);
            this.radButtonElement1.DisplayStyle = DisplayStyle.Image;

            this.radButtonElement2.Image = bmp2.GetThumbnailImage(170, 100, AbortCallback, IntPtr.Zero);
            this.radButtonElement2.DisplayStyle = DisplayStyle.Image;
        }

        private bool AbortCallback()
        {
            return false;
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            CopyPanels();
        }

        private void HideAllPanels()
        {
            this.radPanel1.Visible = false;
            this.panel2.Visible = false;
        }

        private void Form1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            if (e.KeyCode == Keys.Escape)
            {
                RefreshPanels();
                HideAllPanels();
                this.StartLooping();
            }
        }


        private void RefreshPanels()
        {
            if (!this.radPanel1.Visible && !this.panel2.Visible)
                return;

            //update panel images
            this.radPanel1.Bounds = new Rectangle(-1000, -1000, 359, 238);
            this.panel2.Bounds = new Rectangle(-1000, -1000, 359, 238);

            this.radPanel1.Visible = true;
            this.panel2.Visible = true;

            this.CopyPanels();            
        }

        private void Form1_Click(object sender, EventArgs e)
        {
            RefreshPanels();
            HideAllPanels();
            this.StartLooping();
        }

        private void radButtonElement1_MouseDown(object sender, MouseEventArgs e)
        {
            this.StopLooping();
            HideAllPanels();

            if (this.radCarousel1.SelectedItem == this.radButtonElement1)
            {
                this.radPanel1.Visible = true;
                this.radPanel1.Bounds = new Rectangle(120, 120, 359, 238);
            }
        }

        private void radButtonElement2_MouseDown(object sender, MouseEventArgs e)
        {
            this.StopLooping();
            HideAllPanels();

            if (this.radCarousel1.SelectedItem == this.radButtonElement2)
            {
                this.panel2.Visible = true;
                this.panel2.Bounds = new Rectangle(120, 120, 359, 238);
            }
        }

        private void radCarousel1_SelectedIndexChanged(object sender, EventArgs e)
        {
            RefreshPanels();
            HideAllPanels();            
        }                
    }
}